/* REXX - Rulez 
   PortScanner 1 // (c) 1998, Andrew Alexeyenko, chaos@falt.deep.ru
   PortScanner 1 // (c) 1999, Dmitriy Mihantyev, mda@seb.ru (#os2russian - _mda_)
*/
PARSE ARG address pfrom pto unap

IF address='' THEN DO
    SAY 'USAGE: PortScan1.CMD <dotted ip address>||<host name> <begin port> <end port> [anything - print unavailable ports]'
    exit
    END

if pfrom='' then
   pfrom=1

if pto='' then
   pto = 65535

call rxFuncAdd "SysGetKey", "RexxUtil", "SysGetKey"
rc = RxFuncAdd("SockLoadFuncs","rxSock","SockLoadFuncs")
rc = SockLoadFuncs()

serv=VALUE('ETC',,'OS2ENVIRONMENT')'\services'

if VERIFY(address,'1234567890.')<>0 then do
    rc=SockGetHostByName(address, 'host.')
    if rc = 1 then
        newaddr = host.addr
    else do
        say 'Unknown host 'address
        exit
    end
end
else
    newaddr = address

SAY 'Connecting to 'newaddr

SAY 'Successfuly connected with 'newaddr', services present:'
rc=STREAM(serv,'C','open read')

addr.addr=newaddr
addr.family = AF_INET

DO WHILE STREAM(serv) = 'READY'
    PARSE VALUE LINEIN(serv) WITH service addr.port'/'soc_type comment
    if translate(soc_type)='TCP' then do
       addr.port = STRIP(addr.port,'b')
       comment = STRIP(comment,'b')
       i=addr.port
       ports.i.addr = i
       ports.i.serv = service
       ports.i.comm = comment
    end
END
rc = STREAM(serv,'C','close')

do port=pfrom TO pto
    addr.port = port
    sock = SockSocket(AF_INET, SOCK_STREAM, 0)
    IF sock>-1 THEN 
    DO
        rc = SockConnect(sock,"addr.")
        IF rc>-1 THEN DO
           if ports.port.addr<>'PORTS.'port'.ADDR' then
              SAY ' 'LEFT(ports.port.addr,6) LEFT(ports.port.serv,10)' 'ports.port.comm
           else
              SAY ' 'LEFT(addr.port,6)' unknown service'
        END
           ELSE if \(unap='')
              THEN SAY 'port  'LEFT(addr.port,6)' is not available'

    END
    ELSE
        SAY 'Unable to get socket.'
    rc = SockClose(sock)
end
rc = SockDropFuncs()
